unit PASTDOC;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, IniFiles, ExtCtrls, Buttons, ToolWin, ComCtrls, Menus
  ;


Const
  wpUp       = 1;(*ѼV*)
  wpDown     = 2;(*ѼYp*)
  TheMsgConstant     = 'MyUniqueMessageConstant';(*o@Ӧ@Ϊǿ id *)


type
  TPdForm = class(TForm)
    OpenDialog1: TOpenDialog;
    Notebook1: TNotebook;
    ListBox1: TListBox;
    Memo1: TMemo;
    Button1: TButton;
    Button2: TButton;
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    E1: TMenuItem;
    G1: TMenuItem;
    F61: TMenuItem;
    F71: TMenuItem;
    F81: TMenuItem;
    F91: TMenuItem;
    F101: TMenuItem;
    F111: TMenuItem;
    F121: TMenuItem;
    procedure FuncKeyClick(GpName:string);
    procedure AutoLinkPd;
    procedure GetLinkPd;    
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormActivate(Sender: TObject);
    procedure ListBox1KeyPress(Sender: TObject; var Key: Char);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure E1Click(Sender: TObject);
    procedure ListBox1DrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure ChangeTitle;
    procedure F61Click(Sender: TObject);
    procedure F71Click(Sender: TObject);
    procedure F81Click(Sender: TObject);
    procedure F91Click(Sender: TObject);
    procedure F101Click(Sender: TObject);
    procedure F111Click(Sender: TObject);
    procedure F121Click(Sender: TObject);
  private
    TheMsgVal      : Word;(*ǰeƭ*)
    function FindKeys(iFileName:string;Sec:string;key:string;Default:string):string;
    function WritKeys(iFileName:string;Sec:string;key:string;Value:string):boolean;
  public
    function ForceForegroundWindow(hwnd: THandle): Boolean;  
    procedure WndProc(var TheMsg: TMessage); override;(*ݨϥ*)
  end;

var
  PdForm: TPdForm;
  FIniFileName : string;
  FTargetDocus : string;(*ثewɦW*)
  cTargetWords : string;
  GpName : string;(*sզW*)
  nd : string;(*ɥؿ*)
  ActHand : Hwnd;(*ؼе*)
  ActHanded : Hwnd;(*Wؼе*)
  ALkls, Pdfls : Tstringlist;(*sɤs*)
  IsHasLinkFile: boolean;(*Ss*)
implementation

{$R *.DFM}

uses clipbrd;

const
    SectionData      = 'System';
    KeyTargetTitle   = 'TargetTitle';
    KeyTargetWords   = 'TargetWords';
    KeyTargetDocus   = 'TargetDocus';
    KeyMyTop         = 'MyTop';
    KeyMyLeft        = 'MyLeft';

function EnableHotKeyHook: BOOL; external 'PasteDoc.DLL';
function DisableHotKeyHook: BOOL; external 'PasteDoc.DLL';

(*NY]̤Wh*)
function TPdForm.ForceForegroundWindow(hwnd: THandle): Boolean;
var
    ForegroundThreadID  :   DWORD;
    ThisThreadID        :   DWORD;
begin
    if IsIconic(hwnd) then
        ShowWindow(hwnd, SW_RESTORE);

    if GetForegroundWindow = hwnd then
        Result := true
    else begin
        //pG@ӵL foucsAWindows 98/2000 |t@ӵe
        if( ( Win32Platform = VER_PLATFORM_WIN32_NT ) and ( Win32MajorVersion > 4 ) ) or
            ( ( Win32Platform = VER_PLATFORM_WIN32_WINDOWS ) and
            ( (Win32MajorVersion > 4 ) or ( ( Win32MajorVersion = 4 ) and
            ( Win32MinorVersion > 0 ) ) ) ) then
        begin
            Result  :=  false;
            ForegroundThreadID  :=  GetWindowThreadProcessID( GetForegroundWindow , nil );
            ThisThreadID        :=  GetWindowThreadProcessId( hwnd , nil);
            if AttachThreadInput( ThisThreadID , ForegroundThreadID, true) then
            begin
                BringWindowToTop( hwnd );
                SetForegroundWindow( hwnd );
                AttachThreadInput(ThisThreadID, ForegroundThreadID, false);
                Result := (GetForegroundWindow = hwnd);
            end;
            if not Result then
            begin
                ///SystemParametersInfo(SPI_SETFOREGROUNDLOCKTIMEOUT, 0, @timeout, 0);
                ///SystemParametersInfo(SPI_SETFOREGROUNDLOCKTIMEOUT, 0, TObject(0), SPIF_SENDCHANGE);
                BringWindowToTop(hwnd);
                SetForegroundWindow(hWnd);
                //SystemParametersInfo(SPI_SETFOREGROUNDLOCKTIMEOUT, 0, TObject(timeout), SPIF_SENDCHANGE);
            end;
        end
        else begin
            BringWindowToTop(hwnd);
            SetForegroundWindow(hwnd);
        end;
        Result := (GetForegroundWindow = hwnd);
    end;
end; { ForceForegroundWindow }

function TPdForm.FindKeys(iFileName:string;Sec:string;key:string;Default:string):string;
var
  IniFile : TIniFile;
begin
  IniFile := TIniFile.Create(iFileName);
  result := IniFile.ReadString(Sec, Key, Default);
  IniFile.Free;
end;

function TPdForm.WritKeys(iFileName:string;Sec:string;key:string;Value:string):boolean;
var
  IniFile : TIniFile;
begin
  IniFile := TIniFile.Create(iFileName);
  try
   IniFile.WriteString(Sec, Key,Value);
   result := true;
  finally
   IniFile.Free;
  end;
end;

(*UF6-F12᪺ʧ@*)
procedure TPdForm.FuncKeyClick(GpName:string);
begin
  FTargetDocus := FindKeys(FIniFilename,SectionData,GpName, FTargetDocus);
  if fileexists(nd+'\'+FTargetDocus) then begin
     listbox1.Items.LoadFromFile(nd+'\'+FTargetDocus);
     changetitle;
     if listbox1.items.Count >0 then begin
        listbox1.ItemIndex := 0;
     end;
  end;
end;


(*۳sɨow*)
procedure TPdForm.AutoLinkPd;
var
  CharArray : array[0..254] of char;
  ActWinText: string;
  idx : integer;
begin
    GetWindowText(ActHand, CharArray, 255);
    ActWinText := CharArray;
    idx := ALkls.IndexOf(ActWinText);
    if idx <> -1 then
    begin
       FTargetDocus := Pdfls.Strings[idx];
       if fileexists(nd+'\'+FTargetDocus) then begin
           listbox1.Items.LoadFromFile(nd+'\'+FTargetDocus);
           ChangeTitle;
           if listbox1.items.Count >0 then begin
              listbox1.ItemIndex := 0;
           end;
       end;
    end;
end;

(*NsɸmȦs*)
procedure TPdForm.GetLinkPd;
var
  LPd : Tstringlist;
  i : integer;
  tmp: string;
begin
  Lpd := Tstringlist.Create;
  try
    Lpd.LoadFromFile(nd+'\'+'LinkPd.inf');
    ALkls := Tstringlist.Create;
    Pdfls := Tstringlist.Create;
    for i:=0 to Lpd.Count -1 do
    begin
        tmp := Lpd.Strings[i];
        Alkls.Add(copy(tmp,1,pos('=',tmp)-1));
        delete(tmp,1,pos('=',tmp));
        PdfLs.Add(tmp);
    end;
  finally
    lpd.Free;
  end;
end;

(*קY*)
procedure TPdForm.ChangeTitle;
begin
     PdForm.Caption := extractfilename(FTargetDocus) +' - '+ '[w]';
     Application.Title :=  PdForm.Caption;
end;

procedure TPdForm.FormCreate(Sender: TObject);
begin
  TheMsgVal := RegisterWindowMessage(TheMsgConstant); (*o@Ӧ@Ϊǿ id *)
  EnableHotKeyHook;
  notebook1.ActivePage := 'paster';
  getdir(0,nd);
  FIniFileName := nd + '\' + LowerCase(ExtractFileName(Application.ExeName));
  FIniFileName := Copy(FIniFileName, 1, Length(FIniFileName) - 3) + 'ini';
  GpName := FindKeys(FIniFilename,SectionData,KeyTargetDocus, 'Group1');
  FTargetDocus:= nd + '\' + 'PastDoc.txt';
  FTargetDocus := FindKeys(FIniFilename,SectionData,GpName, FTargetDocus);
  if fileexists(FTargetDocus) then begin
     listbox1.Items.LoadFromFile(FTargetDocus);
     ChangeTitle;
  end
  else begin
     showmessage(FTargetDocus+' ¤rɧ䤣 !!');
  end;
  PdForm.Top :=  strtoint(FindKeys(FIniFilename,SectionData,KeyMyTop, '0'));
  PdForm.Left := strtoint(FindKeys(FIniFilename,SectionData,KeyMyLeft, '0'));
end;

procedure TPdForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  DisableHotKeyHook;
  WritKeys(FIniFileName,SectionData,KeyTargetDocus, GpName);
  WritKeys(FIniFileName,SectionData,KeyMyTop,  inttostr(PdForm.Top));
  WritKeys(FIniFileName,SectionData,KeyMyLeft, inttostr(PdForm.Left));
end;

procedure TPdForm.FormActivate(Sender: TObject);
var
  sIndex , i: integer;
begin
  cTargetWords := FindKeys(FIniFileName,SectionData,KeyTargetWords, '');
  if listbox1.Items.Count > 0 then begin
     sIndex :=Listbox1.Items.IndexOf(cTargetWords);
     if sIndex <> -1 then begin
       Listbox1.ItemIndex := sIndex;
     end
     else begin
       Listbox1.ItemIndex := 0;
     end;
  end;
  // oCgroup
  for i:=0 to G1.Count - 1 do
  begin
      FTargetDocus := FindKeys(FIniFileName,SectionData,'Group'+inttostr(i+1), '');
      if FTargetDocus<>'' then
         G1.Items[i].Caption := extractfilename(FTargetDocus);
  end;
  if fileexists(nd + '\' + 'linkpd.inf') then
  begin
     GetLinkPd;
     IsHasLinkFile := true;
  end
  else
  begin
     IsHasLinkFile := false;
  end;
end;

(*ϥΪ̫UEnter*)
procedure TPdForm.ListBox1KeyPress(Sender: TObject; var Key: Char);
begin
   if key = #13 then begin
      if (listbox1.Items.Count > 0) then begin
         (*NmJŶKï*)
         Clipboard.SetTextBuf(Pchar(trim(listbox1.Items[listbox1.Itemindex])));
         (*Nؼе{m̤Wh*)
         SetForegroundWindow(ActHand);
         (*UCtrl-V*)
         keybd_event(Ord(#17),0,0,0);//Uctrl
         keybd_event(Ord(#86),0,0,0);//Uv
         keybd_event(Ord(#86), 0, KEYEVENTF_KEYUP, 0);//}v
         keybd_event(Ord(#17), 0, KEYEVENTF_KEYUP, 0);//}ctrl
      end;
   end;
end;


(*קw*)
procedure TPdForm.Button2Click(Sender: TObject);
var
  sIndex : integer;
begin
   Notebook1.PageIndex := 0;
   if listbox1.Items.Count > 0 then begin
     sIndex :=Listbox1.Items.IndexOf(cTargetWords);
     if sIndex <> -1 then begin
       Listbox1.ItemIndex := sIndex;
     end
     else begin
       Listbox1.ItemIndex := 0;
     end;
   end;
end;

(*קwTw*)
procedure TPdForm.Button1Click(Sender: TObject);
var
  sIndex : integer;
begin
   Notebook1.PageIndex := 0;
   listbox1.Items.Assign(memo1.Lines);
   listbox1.Items.SaveToFile(FTargetDocus);
   if listbox1.Items.Count > 0 then begin
     sIndex :=Listbox1.Items.IndexOf(cTargetWords);
     if sIndex <> -1 then begin
       Listbox1.ItemIndex := sIndex;
     end
     else begin
       Listbox1.ItemIndex := 0;
     end;
   end;
end;

(* dll *)
procedure TPdForm.WndProc(Var TheMsg: TMessage);
begin
  if TheMsg.Msg = TheMsgVal then
    case TheMsg.wParam of
      wpUp   :
             begin
                 ActHand := GetForegroundWindow;(*o̤Wh*)
                 if ActHand <> handle then begin(*T{Oۤv*)
                    if ActHanded <> ActHand then(*YOP@*)
                    begin
                      if IsHasLinkFile then(*sɮ*)
                         AutoLinkPd;(*۳sɨow*)
                    end;
                 end;
                 ShowWindow(handle, SW_show);
                 ForceForegroundWindow(handle);
                 ActHanded := ActHand;(*OۤW*)
             end;
      wpDown    :
             begin
                 ShowWindow(handle, SW_Hide);
                 ForceForegroundWindow(ActHand);(*N̤Wh]ؼе*)
             end;
    end;
  Inherited WndProc(TheMsg);
end;


(*sw*)
procedure TPdForm.N1Click(Sender: TObject);
begin
    OpenDialog1.FileName :='*.txt';
    OpenDialog1.InitialDir := extractfiledir(application.ExeName);
    if OpenDialog1.Execute then begin
       FTargetDocus := OpenDialog1.FileName;
       Listbox1.Items.LoadFromFile(FTargetDocus);
       ChangeTitle;
       G1.Items[strtoint(copy(GpName,length('Group')+1,1))-1].Caption := extractfilename(FTargetDocus);
       if listbox1.items.Count >0 then begin
          listbox1.ItemIndex := 0;
       end;
       WritKeys(FIniFileName,SectionData,KeyTargetDocus, GpName);
       WritKeys(FIniFileName,SectionData,GpName, extractfilename(FTargetDocus));
    end;
end;

(*קw*)
procedure TPdForm.E1Click(Sender: TObject);
begin
    Notebook1.PageIndex := 1;
    memo1.Lines.Assign(listbox1.Items);
end;

(*ק listbox C*)
procedure TPdForm.ListBox1DrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var c: TCanvas;
begin
  c := ListBox1.Canvas;
  if not (odSelected in State) then begin
    c.Brush.Color := clGray;
    c.Font.Color := clWhite;
  end else begin
    c.Brush.Color := clInfoBk;
    c.Font.Color :=clPurple;
  end;
  c.FillRect(Rect);
  c.TextOut(Rect.Left, Rect.Top, ListBox1.Items[Index]);
end;

procedure TPdForm.F61Click(Sender: TObject);
begin
  GpName := 'Group1';
  FuncKeyClick(GpName);
end;

procedure TPdForm.F71Click(Sender: TObject);
begin
  GpName := 'Group2';
  FuncKeyClick(GpName);
end;

procedure TPdForm.F81Click(Sender: TObject);
begin
  GpName := 'Group3';
  FuncKeyClick(GpName);
end;

procedure TPdForm.F91Click(Sender: TObject);
begin
  GpName := 'Group4';
  FuncKeyClick(GpName);
end;

procedure TPdForm.F101Click(Sender: TObject);
begin
  GpName := 'Group5';
  FuncKeyClick(GpName);
end;

procedure TPdForm.F111Click(Sender: TObject);
begin
  GpName := 'Group6';
  FuncKeyClick(GpName);
end;

procedure TPdForm.F121Click(Sender: TObject);
begin
  GpName := 'Group7';
  FuncKeyClick(GpName);
end;

end.


